/**
 * 
 */
package myproject{
	import flash.display.MovieClip;
	import jp.progression.commands.display.AddChildAt;
	import jp.progression.commands.display.RemoveChild;
	import jp.progression.scenes.SceneObject;
	
	/**
	 * SlideShowScene クラス
	 */
	public class SlideShowScene extends SceneObject {
		
		/**
		 * コンストラクタ
		 */
		public function SlideShowScene( name:String = null, initObject:Object = null ) {
			super( name, initObject );
			
			// ブラウザ同期時に出力したいタイトルを設定します。
			title = "スライドショー";
			
			var photo1:SceneObject = new Photo1Scene;
			photo1.name = "photo1";
			addScene(photo1);
			var photo2:SceneObject = new Photo2Scene;
			photo2.name = "photo2";
			addScene(photo2);
			var photo3:SceneObject = new Photo3Scene;
			photo3.name = "photo3";
			addScene(photo3);
		}
		
		private var thumb:MovieClip = new SlideshowSprite();
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは子階層だった場合に、階層が変更された瞬間に送出されます。
		 * このイベント処理の実行中には、addCommand() メソッド、及び insertCommand() メソッドによるコマンドの同期処理が行えます。
		 */
		protected override function atSceneLoad():void {
			// 実行したいコマンドを登録します。
			addCommand(
				new AddChildAt(container, thumb, 50)
			);
		}
		
		/**
		 * シーン移動時に目的地がシーンオブジェクト自身もしくは親階層だった場合に、階層が変更された瞬間に送出されます。
		 * このイベント処理の実行中には、addCommand() メソッド、及び insertCommand() メソッドによるコマンドの同期処理が行えます。
		 */
		override protected function atSceneUnload():void {
			// 実行したいコマンドを登録します。
			addCommand(
				new RemoveChild(container, thumb)
			);
		}
	}
}
